#include <iostream>

// needs gcc ≥ 14 or clang ≥ 18 with -std=c++23

struct container {
	auto operator[](this auto& self, int index) {
		// self is either container& or const container&
		self.show_const();
		// ... some long computation ...
		return index;
	}
	// note: without deducing this, a good (DRY) solution needs
	// an auxiliary static member function

	void show_const() { std::cout << "non-const\n"; }
	void show_const() const { std::cout << "const\n"; }
};

int main() {
	container c;
	int x = c[0];
	const container& cc = c;
	x = cc[0];
}
