#include <concepts>
#include <iostream>

template <typename T, typename U>
void show_same(const T& /* unused */, const U& /* unused */) {
	if constexpr (std::same_as<T, U>) {
		std::cout << "same type\n";
	} else {
		std::cout << "different type\n";
	}
}

void println(auto&& ... args) {
	(std::cout << ... << args) << '\n';
}

int main() {
	println("Hello", ',', " world!");
	show_same(1, 2);
	show_same(3.14, 0.f);
}
